package com.docus.server.infrastructure.dao.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.docus.core.util.Func;
import com.docus.infrastructure.core.db.dao.impl.BaseDaoImpl;
import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.entity.scheduling.management.SchCollectorVersionLog;
import com.docus.server.infrastructure.dao.ISchCollectorVersionLogDao;
import com.docus.server.infrastructure.mapper.SchCollectorVersionLogMapper;
import com.github.pagehelper.PageHelper;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * 采集器版本更新日志管理 数据访问实现类
 *
 * @author AutoGenerator
 * @since 2023-07-15
 */
@Repository
public class SchCollectorVersionLogDaoImpl extends BaseDaoImpl<SchCollectorVersionLogMapper, SchCollectorVersionLog> implements ISchCollectorVersionLogDao {

    /**
     * 按主键查询
     *
     * @param id 主键Id
     * @return 实体
     */
    @Override
    public SchCollectorVersionLog findById(String id) {
        return super.findById(id);
    }

    /**
     * 新增
     *
     * @param schCollectorVersionLog 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean add(SchCollectorVersionLog schCollectorVersionLog) {
        return super.save(schCollectorVersionLog);
    }

    /**
     * 编辑
     *
     * @param schCollectorVersionLog 编辑参数
     * @return 成功或失败
     */
    @Override
    public boolean edit(SchCollectorVersionLog schCollectorVersionLog) {
        return super.updateById(schCollectorVersionLog);
    }

    /**
     * 批量删除
     *
     * @param ids 主键ids
     * @return 成功或失败
     */
    @Override
    public int delete(List<Long> ids) {
        return super.deleteByIds(ids);
    }

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    @Override
    public PageResult<SchCollectorVersionLog> search(SearchDTO searchDTO) {
        //分页
        PageHelper.startPage(searchDTO.getPageNum(), searchDTO.getPageSize());
        LambdaQueryWrapper<SchCollectorVersionLog> query = Wrappers.lambdaQuery();
        //时间范围，默认按createTime
        if (searchDTO.getBeginTime() != null) {
            query.ge(SchCollectorVersionLog::getCreateTime, searchDTO.getBeginTime());
        }
        if (searchDTO.getEndTime() != null) {
            Date endTime = searchDTO.getEndTime();
            query.le(SchCollectorVersionLog::getCreateTime, endTime);
        }
        Object collectorId = searchDTO.getParams("collectorId");
        if (Func.isNotEmpty(collectorId)) {
            query.eq(SchCollectorVersionLog::getCollectorId, collectorId);
        }
        //默认createTime倒序排序
        query.orderByDesc(SchCollectorVersionLog::getCreateTime);
        List<SchCollectorVersionLog> list = super.find(query);
        return new PageResult<>(list);
    }

}
